### BEGIN LICENSE
"""
This program is free software: you can redistribute it and/or modify it 
under the terms of the GNU General Public License version 3, as published 
by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranties of 
MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along 
with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
### END LICENSE

from gi.repository import Gtk, Gio, Gdk
from gi.repository.GdkPixbuf import Pixbuf
import os

def InitDisplay(self,builder, sourceFolder,sourceInterval):
    files = 0
    files_jpg = 0
    files_png = 0
    self.builder.get_object("folderChooser").set_current_folder(sourceFolder)
    self.builder.get_object("intervalEdit").set_value(int(sourceInterval))
    iconStore = Gtk.ListStore(Pixbuf)
    iconview = self.builder.get_object("displayView")
    iconview.set_columns(-1)
    iconview.set_model(iconStore)
    iconview.set_pixbuf_column(0)
    Status = self.builder.get_object("status")
    for name in os.listdir(sourceFolder):
        filename = os.path.join(sourceFolder, name)
        if name.endswith(".jpg") or name.endswith(".png"):
            if name.endswith(".jpg"):
                files_jpg = files_jpg + 1
            if name.endswith(".png"):
                files_png = files_png + 1
            files = files + 1 
            pixbuf = Pixbuf.new_from_file_at_size(filename,96,96)
            iconStore.append([pixbuf])
        else:
            print ("%s not a image file!" % (filename))
    Status.push(1,"%s images found (%s .jpg, %s .png)" % (files, files_jpg, files_png))
    print "+++++++"
    return
