# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
"""
This program is free software: you can redistribute it and/or modify it 
under the terms of the GNU General Public License version 3, as published 
by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranties of 
MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along 
with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
### END LICENSE

import gettext
from gettext import gettext as _
gettext.textdomain('pictoric')

from gi.repository import Gtk, Gio, Gdk # pylint: disable=E0611
from gi.repository.GdkPixbuf import Pixbuf
import logging
logger = logging.getLogger('pictoric')

import os,time

from pictoric_lib import Window

class PictoricWindow(Window):
    __gtype_name__ = "PictoricWindow"
    SCHEMA = 'org.gnome.desktop.background'
    KEY = 'picture-uri'
    minute=60
    defaultDirectory = '/home/%s/Pictures' % (os.environ['USER'])
    defaultInterval = minute*5  
    sourceFolder = defaultDirectory
    def finish_initializing(self, builder, sourceFolder=defaultDirectory, sourceInterval=defaultInterval, configPath ='/home/%s/.config/pictoric.conf' % (os.environ['USER']), minute=60): # pylint: disable=E1002
        """Set up the main window"""
       # self.set_default_size(400,500)
        if os.path.isfile(configPath) == False: #Tests if config file already exists
            print "Writing '%s'" % (configPath)
            config = open("%s" % (configPath), 'w')
            config.write("%s\n" % (sourceFolder))
            config.write("%s\n" % (sourceInterval))
            config.close()
        if os.path.isfile(configPath) == True: #If exists, open for reading and future writing
            config = open("%s" % (configPath), 'r')
            sourceFolder = config.readline()
            sourceInterval = config.readline()
            config.close()
            #print "Init:",sourceFolder
        #Set color
        #Color = Gdk.Color(56,54,53)
        #self.set_background(Color)
        super(PictoricWindow, self).finish_initializing(builder)

    def changer(self,dir_path,sourceInterval=defaultInterval, minute=60):
        print "Starting wallpaper slideshow with folder->'%s' and interval->%s" % (dir_path,sourceInterval)
        gsettings = Gio.Settings.new(self.SCHEMA)
        for name in os.listdir(dir_path):
            background = (os.path.join(dir_path, name))
            if name.endswith(".jpg") or name.endswith(".png"):
                time.sleep(float(sourceInterval)*minute)
                gsettings.set_string(self.KEY, "file://" + background)
                print "Set new background '%s' in %s minute(s)!" % (background, sourceInterval)
            else:
                print "Warning: Tried setting background, but '%s' is not a image file!" % (background)
        return
        
    def button_apply(self, builder, sourceFolder=defaultDirectory,sourceInterval=defaultInterval, configPath ='/home/%s/.config/pictoric.conf' % (os.environ['USER'])):
        print "Saving '%s'" % (configPath)
        sourceFolder = self.builder.get_object("folderChooser").get_filename()
        sourceInterval = self.builder.get_object("intervalEdit").get_text()
        if sourceInterval == '0':
            sourceInterval = 5
        config = open("%s" % (configPath), 'w')
        config.write("%s\n" % (sourceFolder))
        config.write("%s\n" % (sourceInterval))
        self.destroy()
    
        
    def button_cancel(self, builder):
        Gtk.main_quit()
        raise SystemExit(0)

    def update_folder(self, builder,sourceFolder=sourceFolder):
        files = 0
        files_jpg = 0
        files_png = 0
        sourceFolder = self.builder.get_object("folderChooser").get_filename()
        iconStore = Gtk.ListStore(Pixbuf)
        iconview = self.builder.get_object("displayView")
        iconview.set_columns(-1)
        iconview.set_model(iconStore)
        iconview.set_pixbuf_column(0)
        Status = self.builder.get_object("status")
        for name in os.listdir(sourceFolder):
            filename = os.path.join(sourceFolder, name)
            if name.endswith(".jpg") or name.endswith(".png"):
                if name.endswith(".jpg"):
                    files_jpg = files_jpg + 1
                if name.endswith(".png"):
                    files_png = files_png + 1
                files = files + 1
                pixbuf = Pixbuf.new_from_file_at_size(filename,96,96)
                iconStore.append([pixbuf])
            else:
                print "Warning: '%s' is not a image file!" % (filename)
        Status.push(1,"%s images found (%s .jpg, %s .png)" % (files, files_jpg, files_png))
        print "+++++++++"
        return

    def change_interval(self, builder):
        #print self.builder.get_object("intervalEdit").get_text()
        return
        


